<?php
/*
Plugin Name: ak-quote
Plugin URI: http://blog.akebi.jp/archives/257
Description: 行頭に引用文字のある行に任意のclassを追加
Version: 0.1
Author: Akebi
Author URI: http://blog.akebi.jp/
*/

function ak_quote_replace($str) {

	$quote_cs = array(
		'>'   => 'ak-quote1',
		'＞'  => 'ak-quote2',
		'|'   => 'ak-quote3',
		''    => '',
	);
	
	$m = "\xff";
	$str = "{$m}{$str}{$m}";
	$str = preg_replace("/\r?\n/", "{$m}{$m}", $str);
	
	foreach ($quote_cs as $k => $v) {
		if (trim($k)==='') { continue;}
		$k = quotemeta($k);
		$k = str_replace("|", "\\|", $k);
		$str = preg_replace("/{$m}({$k}){$m}/", "{$m}$1 {$m}", $str);
		$str = preg_replace("/(({$m}(<p>)?{$k}[^{$m}]+{$m})+)/", "{$m}<div class='{$v}'>$1</div>{$m}", $str);
		$str = str_replace("{$m}<div class='{$v}'>{$m}<p>", "{$m}<p>{$m}<div class='{$v}'>", $str);
		$str = str_replace("</p>{$m}</div>{$m}", "</div>{$m}</p>{$m}", $str);
	}
	$str = preg_replace("/{$m}{$m}/","\n", $str);
	$str = str_replace("{$m}", '', $str);
	
	return($str);
}

function ak_quote_init() {
	$url = get_bloginfo('wpurl');
	print<<<HTML

	<link rel="stylesheet" type="text/css" href="{$url}/wp-content/plugins/ak-quote/ak-quote.css" />

HTML;
}

add_action('wp_head', 'ak_quote_init');
add_filter('the_content', 'ak_quote_replace', 10);
add_filter('comment_text', 'ak_quote_replace', 30);
?>